/**

   with-lasers.studio / lxinspc

   project name: BoidSynth
   file name: WaveTables.h

   created: 03/05/2022

   Loads wave tables generated by NoiseWavetables (which generates a landscape usig ocatve noise) and stores them
   in banks of however many wavetables have been loaded (generally 100, consisting of 50 North-South extract and
   50 East-West extracts)

   see https://gitlab.com/mfaComputationalArts/modules/advanced-audio-visual-processing/noisewavetable for
   the noiseWaveTable code
 
*/

#pragma once

//openFrameworks includes
#include "ofMain.h"

//add on includes


//local project includes
#include "WaveTableOsc.h"


class WaveTables {
  
public:
  
  typedef shared_ptr<WaveTables> Ptr;
  
  WaveTables(int nBanks);
  
  
  WaveTableOsc::WaveTablePtr getRandomWaveTable();
  WaveTableOsc::WaveTablePtr getWaveTable(int bank, int id);
  
private:
  
  typedef map<int, WaveTableOsc::WaveTablePtr> Bank;
  typedef map<int, Bank> Banks;

  Banks _banks;
  
  const int N_BANKS = 3;
  
  void _loadFile(string filename, int bank);
  
};




